/* ReWrAp
 *
 * Version 1.4
 * 11/25/2020
 *
 * Main program for Read (re)
 *
 * re.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ftype.h"

#define NAME_FORMAT	"\n/* { %s } */\n\n"

#define _USAGE "Usage: %s [-n|--filename] <file ...>\n"

int main(int argc, char *argv[])
{
	FILE *fptr;
	
	int c;
	int a, b, shownames;

	if (argc < 2)
	{
		printf(_USAGE, argv[0]);
		exit(1);
	}

	if (!strcmp(argv[1], "-n") || !strcmp(argv[1], "--filename"))
	{
		b = 2;
		shownames = 1;
	} else {
		b = 1;
		shownames = 0;
	}

	for (a = b; a <= (argc - 1); a++)
	{
		if (ftype(argv[a]) == _DIR)
		{
			printf("%s: %s: Is a directory\n", argv[0], argv[a]);
			continue;
		}

		fptr = fopen(argv[a],"r");
   
		if (!fptr)
		{
			printf("%s: %s: File not found\n", argv[0], argv[a]);
			continue;
		}

		rewind(fptr);

		if (shownames)
		{
			printf(NAME_FORMAT, argv[a]);
		}

		while (1)
		{
			c = fgetc(fptr);
			if (feof(fptr))
			{
				break;
			}
			putchar(c);
		}
	
		fclose(fptr);
	}
	
	exit(0);
}
